Index: krita/ui/canvas/kis_canvas_widget_base.h
===================================================================
--- krita/ui/canvas/kis_canvas_widget_base.h	(revision 1163293)
+++ krita/ui/canvas/kis_canvas_widget_base.h	(working copy)
@@ -37,11 +37,12 @@
 class QVariant;
 
 class KoViewConverter;
+class KisCoordinatesConverter;
 
 class KisCanvasWidgetBase : public KisAbstractCanvasWidget
 {
 public:
-    KisCanvasWidgetBase(KisCanvas2 * canvas);
+    KisCanvasWidgetBase(KisCanvas2 * canvas, KisCoordinatesConverter *coordinatesConverter);
 
     virtual ~KisCanvasWidgetBase();
 
@@ -49,19 +50,11 @@
 
     virtual KoToolProxy * toolProxy();
 
-    virtual void documentOffsetMoved(const QPoint &);
-
-    virtual QPoint documentOrigin() const;
-
-    virtual void adjustOrigin();
-
     /**
      * Draw the specified decorations on the view.
      */
-    virtual void drawDecorations(QPainter & gc, bool tools,
-                                 const QPoint & documentOffset,
-                                 const QRect & clipRect,
-                                 KisCanvas2 * canvas);
+    virtual void drawDecorations(QPainter & gc, const QRect &updateWidgetRect);
+
     virtual void addDecoration(KisCanvasDecoration* deco);
     virtual KisCanvasDecoration* decoration(const QString& id);
 
@@ -69,42 +62,22 @@
     virtual QList<KisCanvasDecoration*> decorations();
 
     /**
-     * Returns the color of the border, i.e. the part of the canvas 
-     * outside the image contents. 
+     * Returns the color of the border, i.e. the part of the canvas
+     * outside the image contents.
      *
      */
     QColor borderColor() const;
-    void setBorderColor(const QColor& color);
 
-    
 protected:
     /**
      * Returns one check of the background checkerboard pattern.
-     *
-     * @param checkSize the size of the check
      */
-    QImage checkImage(qint32 checkSize);
+    QImage checkImage(qint32 checkSize = -1);
 
     KisCanvas2 *canvas() const;
 
-    const KoViewConverter *viewConverter() const;
+    KisCoordinatesConverter* coordinatesConverter();
 
-    QPoint documentOffset() const;
-
-    /// document size in widget pixels
-    QSize documentSize() const;
-
-    /// these methods take origin coordinate into account, basically it means (point - origin)
-    QPointF widgetToView(const QPointF& p) const;
-    QRect widgetToView(const QRect& r) const;
-    QPoint viewToWidget(const QPoint& p) const;
-    QRect viewToWidget(const QRect& r) const;
-
-    /// Convert widget coords to document, taking into account document origin and offset.
-    QPointF widgetToDocument(const QPointF& p) const;
-
-    QPointF mirror(const QPointF& pos) const;
-    
     /**
      * Convert a mouse event widget coordinate to a document 
      * coordinate, applying an offset to convert the integer 
@@ -130,9 +103,9 @@
     void processWheelEvent(QWheelEvent *e);
     QVariant processInputMethodQuery(Qt::InputMethodQuery query) const;
     void processInputMethodEvent(QInputMethodEvent *event);
+    void notifyConfigChanged();
 
     /// To be implemented by the derived canvas 
-    virtual void emitDocumentOriginChangedSignal() = 0;
     virtual bool callFocusNextPrevChild(bool next) = 0;
 
 private:
Index: krita/ui/canvas/kis_qpainter_canvas.cpp
===================================================================
--- krita/ui/canvas/kis_qpainter_canvas.cpp	(revision 1163293)
+++ krita/ui/canvas/kis_qpainter_canvas.cpp	(working copy)
@@ -40,6 +40,7 @@
 #include <KoColorSpace.h>
 #include <KoColorSpaceRegistry.h>
 #include <KoShapeManager.h>
+#include "kis_coordinates_converter.h"
 #include <KoZoomHandler.h>
 #include <KoToolManager.h>
 #include <KoToolProxy.h>
@@ -71,17 +72,11 @@
     QBrush checkBrush;
 };
 
-KisQPainterCanvas::KisQPainterCanvas(KisCanvas2 * canvas, QWidget * parent)
+KisQPainterCanvas::KisQPainterCanvas(KisCanvas2 *canvas, KisCoordinatesConverter *coordinatesConverter, QWidget * parent)
         : QWidget(parent)
-        , KisCanvasWidgetBase(canvas)
+        , KisCanvasWidgetBase(canvas, coordinatesConverter)
         , m_d(new Private())
 {
-    // XXX: Reset pattern size and color when the properties change!
-
-    KisConfig cfg;
-
-    connect(KisConfigNotifier::instance(), SIGNAL(configChanged()), SLOT(slotConfigChanged()));
-
     setAutoFillBackground(true);
     setAcceptDrops(true);
     setFocusPolicy(Qt::StrongFocus);
@@ -89,7 +84,8 @@
     setAttribute(Qt::WA_StaticContents);
     setAttribute(Qt::WA_OpaquePaintEvent);
 
-    m_d->checkBrush = QBrush(checkImage(cfg.checkSize()));
+    connect(KisConfigNotifier::instance(), SIGNAL(configChanged()), SLOT(slotConfigChanged()));
+    slotConfigChanged();
 }
 
 KisQPainterCanvas::~KisQPainterCanvas()
@@ -122,63 +118,42 @@
     QPainter gc(this);
 #endif
 
+    KisCoordinatesConverter *converter = coordinatesConverter();
+    QTransform imageTransform = converter->viewportToWidgetTransform();
+
+    gc.save();
+
     gc.setCompositionMode(QPainter::CompositionMode_Source);
     gc.fillRect(QRect(QPoint(0, 0), size()), borderColor());
 
-    // Don't draw the checks if we draw a cached pixmap, because we
-    // need alpha transparency for checks. The precached pixmap
-    // already should contain checks.
-    QRect documentRect = QRect(QPoint(0, 0), documentSize());
-    QRect fillRect = documentRect.translated(documentOrigin());
-    if (!cfg.noXRender()) {
-        if (cfg.scrollCheckers()) {
-            if (documentOffset().x() > 0) {
-                fillRect.adjust(0, 0, documentOffset().x(), 0);
-            } else {
-                fillRect.adjust(documentOffset().x(), 0, 0, 0);
-            }
-            if (documentOffset().y() > 0) {
-                fillRect.adjust(0, 0, 0, documentOffset().y());
-            } else {
-                fillRect.adjust(0, documentOffset().y(), 0, 0);
-            }
-            gc.save();
-            gc.translate(-documentOffset());
-            gc.fillRect(fillRect, m_d->checkBrush);
-            gc.restore();
-        } else {
-            // Checks
-            gc.fillRect(fillRect, m_d->checkBrush);
-        }
-    }
+    QTransform checkersTransform;
+    QPointF brushOrigin;
+    QPolygonF polygon;
 
-    if(canvas()->image()->rootLayer()->childCount()>0) {
-        gc.setCompositionMode(QPainter::CompositionMode_SourceOver);
+    converter->getQPainterCheckersInfo(&checkersTransform, &brushOrigin, &polygon);
+    gc.setPen(Qt::NoPen);
+    gc.setBrush(m_d->checkBrush);
+    gc.setBrushOrigin(brushOrigin);
+    gc.setTransform(checkersTransform);
+    gc.drawPolygon(polygon);
 
-        gc.save();
-        if (canvas()->isCanvasMirrored()){
-            QTransform m = gc.transform();
-            m.translate( documentOrigin().x(), 0);
-            m.scale(-1,1 );
-            m.translate( -documentSize().width(),0 );
-            m.translate( -documentOrigin().x(), 0);
-            gc.setTransform(m);
-        }
-//            if (cfg.noXRender()) {
-//                gc.drawPixmap(ev->rect(), m_d->prescaledProjection->prescaledPixmap(), 
-//                            ev->rect().translated(-documentOrigin()));
-//            } else {
-                gc.drawImage(ev->rect(), m_d->prescaledProjection->prescaledQImage(), 
-                            ev->rect().translated(-documentOrigin()));
-//            }
-    }
+    gc.setTransform(imageTransform);
+    QRectF viewportRect = converter->widgetToViewport(ev->rect());
 
+    gc.setCompositionMode(QPainter::CompositionMode_SourceOver);
+    gc.drawImage(viewportRect, m_d->prescaledProjection->prescaledQImage(),
+                 viewportRect);
+
+    gc.restore();
+
+
 #ifdef DEBUG_REPAINT
     QColor color = QColor(random() % 255, random() % 255, random() % 255, 150);
     gc.fillRect(ev->rect(), color);
 #endif
-    drawDecorations(gc, true, documentOffset(), fillRect.translated(-documentOrigin()), canvas());
-    gc.restore();
+
+    QRect boundingRect = converter->imageRectInWidgetPixels().toAlignedRect();
+    drawDecorations(gc, boundingRect);
     gc.end();
 
 #ifdef INDEPENDENT_CANVAS
@@ -253,13 +228,6 @@
     processWheelEvent(e);
 }
 
-void KisQPainterCanvas::documentOffsetMoved(const QPoint & pt)
-{
-    KisCanvasWidgetBase::documentOffsetMoved(pt);
-    m_d->prescaledProjection->documentOffsetMoved(pt);
-    update();
-}
-
 void KisQPainterCanvas::resizeEvent(QResizeEvent *e)
 {
     QSize size(e->size());
@@ -269,28 +237,18 @@
     if (size.height() <= 0) {
         size.setHeight(1);
     }
-    m_d->prescaledProjection->resizePrescaledImage(size);
-    adjustOrigin();
+
+    coordinatesConverter()->setCanvasWidgetSize(size);
+    m_d->prescaledProjection->notifyCanvasSizeChanged(size);
+    emit needAdjustOrigin();
 }
 
 void KisQPainterCanvas::slotConfigChanged()
 {
-    KisConfig cfg;
-
-    /**
-     * FIXME: Please pay attention to these options:
-     *   - cfg.checkSize();
-     *   - cfg.checkersColor();
-     */
-
-    m_d->checkBrush = QBrush(checkImage(cfg.checkSize()));
+    m_d->checkBrush = QBrush(checkImage());
+    notifyConfigChanged();
 }
 
-void KisQPainterCanvas::emitDocumentOriginChangedSignal()
-{
-    emit documentOriginChanged(documentOrigin());
-}
-
 bool KisQPainterCanvas::callFocusNextPrevChild(bool next)
 {
     return focusNextPrevChild(next);
Index: krita/ui/canvas/kis_grid_manager.cpp
===================================================================
--- krita/ui/canvas/kis_grid_manager.cpp	(revision 1163293)
+++ krita/ui/canvas/kis_grid_manager.cpp	(working copy)
@@ -26,15 +26,16 @@
 #include <qgl.h>
 #endif
 
-#include <QRadioButton>
 
+#include <QTransform>
+
 #include <kaction.h>
 #include <ktoggleaction.h>
 #include <kactioncollection.h>
 #include <kdialog.h>
 #include <klocale.h>
 
-#include <KoViewConverter.h>
+#include "kis_coordinates_converter.h"
 
 #include "kis_config.h"
 #include "kis_grid_painter_configuration.h"
@@ -159,36 +160,34 @@
     m_view->canvas()->update();
 }
 
-#define pixelToView(point) \
-    converter.documentToView( m_view->document()->image()->pixelToDocument(point))
-
-#define viewToPixel(point) \
-    m_view->document()->image()->documentToPixel( converter.viewToDocument( point))
-
-void KisGridManager::drawDecoration(QPainter& gc, const QPoint& documentOffset, const QRect& area, const KoViewConverter &converter)
+void KisGridManager::drawDecoration(QPainter& gc, const QRectF& updateRect, const KisCoordinatesConverter *converter)
 {
-    dbgRender << "drawDecoration";
     KisConfig cfg;
 
     quint32 offsetx = cfg.getGridOffsetX();
     quint32 offsety = cfg.getGridOffsetY();
-    quint32 hspacing = cfg.getGridHSpacing(); // m_doc->gridData().gridX(); // use koffice grid when KOffice grid is on par with Krita grid, and is configurable by whatever mean Krita has to manipulate the grid
-    quint32 vspacing = cfg.getGridVSpacing(); // m_doc->gridData().gridY(); // use koffice grid when KOffice grid is on par with Krita grid, and is configurable by whatever mean Krita has to manipulate the grid
+    quint32 hspacing = cfg.getGridHSpacing();
+    quint32 vspacing = cfg.getGridVSpacing();
     quint32 subdivision = cfg.getGridSubdivisions() - 1;
 
-    // Draw vertical line
     QPen mainPen = KisGridPainterConfiguration::mainPen();
     QPen subdivisionPen = KisGridPainterConfiguration::subdivisionPen();
-    quint32 i = subdivision - (offsetx / hspacing) % (subdivision + 1);
 
-    QPointF bottomRight = viewToPixel(area.bottomRight() + documentOffset);
-    QPointF topLeft = viewToPixel(area.topLeft() + documentOffset);
+    qreal x1, y1, x2, y2;
+    QRectF imageRect = converter->documentToImage(updateRect);
+    imageRect.getCoords(&x1, &y1, &x2, &y2);
 
-    dbgRender << "area = " << area << "topLeft = " << topLeft << " bottomRight = " << bottomRight << " documentOffset = " << documentOffset;
+    QTransform transform = converter->imageToWidgetTransform();
 
+    gc.save();
+    gc.setTransform(transform);
+
+    quint32 i;
+
+    // Draw vertical line
+    i = subdivision - (offsetx / hspacing) % (subdivision + 1);
     double x = offsetx % hspacing;
-    dbgRender << " x = " << x << " hspacing = " << hspacing;
-    while (x <= bottomRight.x()) {
+    while (x <= x2) {
         if (i == subdivision) {
             gc.setPen(mainPen);
             i = 0;
@@ -196,19 +195,18 @@
             gc.setPen(subdivisionPen);
             i++;
         }
-        if (x >= topLeft.x()) {
+        if (x >= x1) {
             // Always draw the full line otherwise the line stippling varies
             // with the location of area and we get glitchy patterns.
-            dbgRender << pixelToView(QPointF(x, topLeft.y())) << " " << pixelToView(QPointF(x, bottomRight.y())) << (bottomRight.y());
-            gc.drawLine(pixelToView(QPointF(x, topLeft.y())), pixelToView(QPointF(x, bottomRight.y())));
+            gc.drawLine(QPointF(x, y1),QPointF(x, y2));
         }
         x += hspacing;
     }
+
     // Draw horizontal line
     i = subdivision - (offsety / vspacing) % (subdivision + 1);
-    double y = offsety % vspacing;
-    dbgRender << " y = " << x << " vspacing = " << vspacing;
-    while (y <= bottomRight.y()) {
+    qreal y = offsety % vspacing;
+    while (y <= y2) {
         if (i == subdivision) {
             gc.setPen(mainPen);
             i = 0;
@@ -216,12 +214,13 @@
             gc.setPen(subdivisionPen);
             i++;
         }
-        if (y >= topLeft.y()) {
-            gc.drawLine(pixelToView(QPointF(topLeft.x(), y)), pixelToView(QPointF(bottomRight.x(), y)));
+        if (y >= y1) {
+            gc.drawLine(QPointF(x1, y), QPointF(x2, y));
         }
         y += vspacing;
     }
 
+    gc.restore();
 }
 
 #include "kis_grid_manager.moc"
Index: krita/ui/canvas/kis_qpainter_canvas.h
===================================================================
--- krita/ui/canvas/kis_qpainter_canvas.h	(revision 1163293)
+++ krita/ui/canvas/kis_qpainter_canvas.h	(working copy)
@@ -49,7 +49,7 @@
 
 public:
 
-    KisQPainterCanvas(KisCanvas2 * canvas, QWidget * parent);
+    KisQPainterCanvas(KisCanvas2 * canvas, KisCoordinatesConverter *coordinatesConverter, QWidget * parent);
 
     virtual ~KisQPainterCanvas();
 
@@ -109,23 +109,13 @@
         return this;
     }
 
-    void documentOffsetMoved(const QPoint &);
-
-signals:
-
-    /**
-     * This signal is emitted when the document origin has changed.
-     * The document origin is the point (in pixel) on the virtual
-     * canvas where the documents origin (0,0) or the top left
-     * corner of the page is. Copied from Karbon
-     */
-    void documentOriginChanged(const QPoint &origin);
-
 protected: // KisCanvasWidgetBase
 
-    virtual void emitDocumentOriginChangedSignal();
     virtual bool callFocusNextPrevChild(bool next);
 
+signals:
+    void needAdjustOrigin();
+
 private slots:
     void slotConfigChanged();
 
Index: krita/ui/canvas/kis_grid_manager.h
===================================================================
--- krita/ui/canvas/kis_grid_manager.h	(revision 1163293)
+++ krita/ui/canvas/kis_grid_manager.h	(working copy)
@@ -56,7 +56,7 @@
     void fastConfig20x20();
     void fastConfig40x40();
 protected:
-    virtual void drawDecoration(QPainter& gc, const QPoint& documentOffset, const QRect& area, const KoViewConverter &converter);
+    void drawDecoration(QPainter& gc, const QRectF& updateRect, const KisCoordinatesConverter *converter);
 
 private:
 
Index: krita/ui/canvas/kis_canvas_decoration.cc
===================================================================
--- krita/ui/canvas/kis_canvas_decoration.cc	(revision 1163293)
+++ krita/ui/canvas/kis_canvas_decoration.cc	(working copy)
@@ -66,12 +66,10 @@
     d->visible = !d->visible;
 }
 
-void KisCanvasDecoration::paint(QPainter& gc, const QPoint & documentOffset, const QRect& area, const KoViewConverter &converter)
+void KisCanvasDecoration::paint(QPainter& gc, const QRectF& updateArea, const KisCoordinatesConverter *converter)
 {
-    if (visible()) {
-        //dbgKrita << "Decoration " << name() << " is visible";
-        drawDecoration(gc, documentOffset, area, converter);
-    }
+    if (visible())
+        drawDecoration(gc, updateArea, converter);
 }
 
 KisView2* KisCanvasDecoration::view() const
Index: krita/ui/canvas/kis_canvas_decoration.h
===================================================================
--- krita/ui/canvas/kis_canvas_decoration.h	(revision 1163293)
+++ krita/ui/canvas/kis_canvas_decoration.h	(working copy)
@@ -24,8 +24,10 @@
 
 class QPoint;
 class QRect;
+class QRectF;
 class QPainter;
 class KoViewConverter;
+class KisCoordinatesConverter;
 class KisView2;
 
 /**
@@ -44,12 +46,14 @@
      * @return whether the decoration is visible.
      */
     bool visible() const;
+
     /**
      * Will paint the decoration on the QPainter, if the visible is set to true.
      *
-     * @param documentOffset the offset of the view in the document, expressed in the view reference (not in the document reference)
+     * @param updateRect dirty rect in document pixels
      */
-    void paint(QPainter& gc, const QPoint & documentOffset, const QRect& area, const KoViewConverter &converter);
+    void paint(QPainter& gc, const QRectF& updateRect, const KisCoordinatesConverter *converter);
+
 public slots:
     /**
      * Set if the decoration is visible or not.
@@ -60,7 +64,8 @@
      */
     void toggleVisibility();
 protected:
-    virtual void drawDecoration(QPainter& gc, const QPoint & documentOffset, const QRect& area, const KoViewConverter &converter) = 0;
+    virtual void drawDecoration(QPainter& gc, const QRectF& updateArea, const KisCoordinatesConverter *converter) = 0;
+
     /**
      * @return the parent KisView
      */
Index: krita/ui/kis_painting_assistant.h
===================================================================
--- krita/ui/kis_painting_assistant.h	(revision 1163293)
+++ krita/ui/kis_painting_assistant.h	(working copy)
@@ -28,7 +28,7 @@
 class QPainter;
 class QRect;
 class QRectF;
-class KoViewConverter;
+class KisCoordinatesConverter;
 
 #include <kis_shared_ptr.h>
 #include <KoGenericRegistry.h>
@@ -77,7 +77,7 @@
      * @param point the coordinates in point in the document reference
      */
     virtual QPointF adjustPosition(const QPointF& point) const = 0;
-    virtual void drawAssistant(QPainter& gc, const QPoint& documentOffset,  const QRect& area, const KoViewConverter &converter) const = 0;
+    virtual void drawAssistant(QPainter& gc, const QRectF& updateRect, const KisCoordinatesConverter *converter) = 0;
     void replaceHandle(KisPaintingAssistantHandleSP _handle, KisPaintingAssistantHandleSP _with);
     const QList<KisPaintingAssistantHandleSP>& handles() const;
     QList<KisPaintingAssistantHandleSP> handles();
Index: krita/ui/tests/kis_coordinates_converter_test.cpp
===================================================================
--- krita/ui/tests/kis_coordinates_converter_test.cpp	(revision 0)
+++ krita/ui/tests/kis_coordinates_converter_test.cpp	(revision 0)
@@ -0,0 +1,325 @@
+/*
+ *  Copyright (c) 2010 Dmitry Kazakov <dimula73@gmail.com>
+ *
+ *  This program is free software; you can redistribute it and/or modify
+ *  it under the terms of the GNU General Public License as published by
+ *  the Free Software Foundation; either version 2 of the License, or
+ *  (at your option) any later version.
+ *
+ *  This program is distributed in the hope that it will be useful,
+ *  but WITHOUT ANY WARRANTY; without even the implied warranty of
+ *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ *  GNU General Public License for more details.
+ *
+ *  You should have received a copy of the GNU General Public License
+ *  along with this program; if not, write to the Free Software
+ *  Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.
+ */
+
+#include "kis_coordinates_converter_test.h"
+#include <QTest>
+
+#include <qtest_kde.h>
+
+#include <QTransform>
+
+#include <KoZoomHandler.h>
+#include <KoColorSpaceRegistry.h>
+#include <kis_image.h>
+
+#include "kis_coordinates_converter.h"
+
+
+void initImage(KisImageSP *image, KoZoomHandler **zoomHandler)
+{
+    const KoColorSpace *cs = KoColorSpaceRegistry::instance()->rgb8();
+    *image = new KisImage(0, 1000, 1000, cs, "projection test");
+    (*image)->setResolution(100, 100);
+
+    *zoomHandler = new KoZoomHandler();
+    (*zoomHandler)->setResolution(100, 100);
+}
+
+void KisCoordinatesConverterTest::testConversion()
+{
+    KisImageSP image;
+    KoZoomHandler *zoomHandler;
+    initImage(&image, &zoomHandler);
+
+    QRectF testRect(100,100,100,100);
+    KisCoordinatesConverter converter(zoomHandler);
+
+    converter.setImage(image);
+    converter.setDocumentOrigin(QPoint(10,10));
+    converter.setDocumentOffset(QPoint(30,30));
+    converter.setCanvasWidgetSize(QSize(500,500));
+
+    zoomHandler->setZoom(1.);
+    converter.notifyZoomChanged();
+
+    QCOMPARE(converter.imageToViewport(testRect), QRectF(80,80,100,100));
+    QCOMPARE(converter.viewportToImage(testRect), QRectF(120,120,100,100));
+
+    QCOMPARE(converter.widgetToViewport(testRect), QRectF(100,100,100,100));
+    QCOMPARE(converter.viewportToWidget(testRect), QRectF(100,100,100,100));
+
+    QCOMPARE(converter.widgetToDocument(testRect), QRectF(1.20,1.20,1,1));
+    QCOMPARE(converter.documentToWidget(testRect), QRectF(9980,9980,10000,10000));
+
+    QCOMPARE(converter.imageToDocument(testRect), QRectF(1,1,1,1));
+    QCOMPARE(converter.documentToImage(testRect), QRectF(10000,10000,10000,10000));
+
+    zoomHandler->setZoom(0.5);
+    converter.notifyZoomChanged();
+
+    QCOMPARE(converter.imageToViewport(testRect), QRectF(30,30,50,50));
+    QCOMPARE(converter.viewportToImage(testRect), QRectF(240,240,200,200));
+
+    QCOMPARE(converter.widgetToViewport(testRect), QRectF(100,100,100,100));
+    QCOMPARE(converter.viewportToWidget(testRect), QRectF(100,100,100,100));
+
+    QCOMPARE(converter.widgetToDocument(testRect), QRectF(2.4,2.4,2,2));
+    QCOMPARE(converter.documentToWidget(testRect), QRectF(4980,4980,5000,5000));
+
+    QCOMPARE(converter.imageToDocument(testRect), QRectF(1,1,1,1));
+    QCOMPARE(converter.documentToImage(testRect), QRectF(10000,10000,10000,10000));
+
+    delete zoomHandler;
+}
+
+void KisCoordinatesConverterTest::testImageCropping()
+{
+    KisImageSP image;
+    KoZoomHandler *zoomHandler;
+    initImage(&image, &zoomHandler);
+
+    KisCoordinatesConverter converter(zoomHandler);
+
+    converter.setImage(image);
+    converter.setDocumentOrigin(QPoint(0,0));
+    converter.setDocumentOffset(QPoint(0,0));
+    converter.setCanvasWidgetSize(QSize(500,500));
+
+    zoomHandler->setZoom(1.);
+    converter.notifyZoomChanged();
+
+    // we do NOT crop here
+    QCOMPARE(converter.viewportToImage(QRectF(900,900,200,200)),
+             QRectF(900,900,200,200));
+
+    delete zoomHandler;
+}
+
+#define CHECK_TRANSFORM(trans,test,ref) QCOMPARE(trans.map(test).boundingRect(), ref)
+//#define CHECK_TRANSFORM(trans,test,ref) qDebug() << trans.map(test).boundingRect()
+
+void KisCoordinatesConverterTest::testTransformations()
+{
+    KisImageSP image;
+    KoZoomHandler *zoomHandler;
+    initImage(&image, &zoomHandler);
+
+    KisCoordinatesConverter converter(zoomHandler);
+
+    converter.setImage(image);
+    converter.setDocumentOrigin(QPoint(10,20));
+    converter.setDocumentOffset(QPoint(30,50));
+    converter.setCanvasWidgetSize(QSize(500,500));
+
+    QRectF testRect(100,100,100,100);
+    QTransform imageToWidget;
+    QTransform documentToWidget;
+    QTransform flakeToWidget;
+    QTransform viewportToWidget;
+
+
+    zoomHandler->setZoom(1.);
+    converter.notifyZoomChanged();
+
+    imageToWidget = converter.imageToWidgetTransform();
+    documentToWidget = converter.documentToWidgetTransform();
+    flakeToWidget = converter.flakeToWidgetTransform();
+    viewportToWidget = converter.viewportToWidgetTransform();
+
+    CHECK_TRANSFORM(imageToWidget, testRect, QRectF(80,70,100,100));
+    CHECK_TRANSFORM(documentToWidget, testRect, QRectF(9980,9970,10000,10000));
+    CHECK_TRANSFORM(flakeToWidget, testRect, QRectF(80,70,100,100));
+    CHECK_TRANSFORM(viewportToWidget, testRect, QRectF(100,100,100,100));
+
+    zoomHandler->setZoom(0.5);
+    converter.notifyZoomChanged();
+
+    imageToWidget = converter.imageToWidgetTransform();
+    documentToWidget = converter.documentToWidgetTransform();
+    flakeToWidget = converter.flakeToWidgetTransform();
+    viewportToWidget = converter.viewportToWidgetTransform();
+
+    CHECK_TRANSFORM(imageToWidget, testRect, QRectF(30,20,50,50));
+    CHECK_TRANSFORM(documentToWidget, testRect, QRectF(4980,4970,5000,5000));
+    CHECK_TRANSFORM(flakeToWidget, testRect, QRectF(80,70,100,100));
+    CHECK_TRANSFORM(viewportToWidget, testRect, QRectF(100,100,100,100));
+
+    delete zoomHandler;
+}
+
+void KisCoordinatesConverterTest::testConsistency()
+{
+    KisImageSP image;
+    KoZoomHandler *zoomHandler;
+    initImage(&image, &zoomHandler);
+
+    KisCoordinatesConverter converter(zoomHandler);
+
+    converter.setImage(image);
+    converter.setDocumentOrigin(QPoint(10,20));
+    converter.setDocumentOffset(QPoint(30,50));
+    converter.setCanvasWidgetSize(QSize(500,500));
+
+    QRectF testRect(100,100,100,100);
+    QTransform imageToWidget;
+    QTransform documentToWidget;
+    QTransform viewportToWidget;
+
+    zoomHandler->setZoom(0.5);
+    converter.notifyZoomChanged();
+
+    imageToWidget = converter.imageToWidgetTransform();
+    documentToWidget = converter.documentToWidgetTransform();
+    viewportToWidget = converter.viewportToWidgetTransform();
+
+    QRectF fromImage = converter.viewportToWidget(converter.imageToViewport(testRect));
+    QRectF fromDocument = converter.documentToWidget(testRect);
+    QRectF fromViewport = converter.viewportToWidget(testRect);
+
+    CHECK_TRANSFORM(imageToWidget, testRect, fromImage);
+    CHECK_TRANSFORM(documentToWidget, testRect, fromDocument);
+    CHECK_TRANSFORM(viewportToWidget, testRect, fromViewport);
+
+    delete zoomHandler;
+}
+
+void KisCoordinatesConverterTest::testRotation()
+{
+    KisImageSP image;
+    KoZoomHandler *zoomHandler;
+    initImage(&image, &zoomHandler);
+
+    KisCoordinatesConverter converter(zoomHandler);
+
+    QSize widgetSize(1000,500);
+    QRectF testRect(800, 100, 300, 300);
+
+    converter.setImage(image);
+    converter.setDocumentOrigin(QPoint(0,0));
+    converter.setDocumentOffset(QPoint(0,0));
+    converter.setCanvasWidgetSize(widgetSize);
+
+    QTransform postprocessingTransform;
+    postprocessingTransform.rotate(30);
+    converter.setPostprocessingTransform(postprocessingTransform);
+
+    zoomHandler->setZoom(1.);
+    converter.notifyZoomChanged();
+
+    QTransform viewportToWidget = converter.viewportToWidgetTransform();
+
+    QRectF boundingRect = viewportToWidget.mapRect(testRect);
+    QRectF directRect = converter.viewportToWidget(testRect);
+
+    QCOMPARE(boundingRect, directRect);
+
+    QRectF referenceRect(QPointF(742.82,53.5898), QSizeF(409.808,409.808));
+
+#define FUZZY(a,b) ((a)-(b) < 0.01)
+
+    QVERIFY(FUZZY(boundingRect.top(), referenceRect.top()));
+    QVERIFY(FUZZY(boundingRect.left(), referenceRect.left()));
+    QVERIFY(FUZZY(boundingRect.width(), referenceRect.width()));
+    QVERIFY(FUZZY(boundingRect.height(), referenceRect.height()));
+
+    delete zoomHandler;
+}
+
+void KisCoordinatesConverterTest::testMirroring()
+{
+    KisImageSP image;
+    KoZoomHandler *zoomHandler;
+    initImage(&image, &zoomHandler);
+
+    KisCoordinatesConverter converter(zoomHandler);
+
+    QSize widgetSize(500,400);
+    QSize flakeSize(1000,1000);
+    QRectF testRect(300, 100, 200, 200);
+
+    converter.setImage(image);
+    converter.setDocumentOrigin(QPoint(0,0));
+    converter.setDocumentOffset(QPoint(200,100));
+    converter.setCanvasWidgetSize(widgetSize);
+
+    QTransform postprocessingTransform;
+    postprocessingTransform.scale(-1,1);
+    converter.setPostprocessingTransform(postprocessingTransform);
+
+    QTransform imageToWidget;
+    QTransform documentToWidget;
+    QTransform flakeToWidget;
+    QTransform viewportToWidget;
+
+    zoomHandler->setZoom(1.);
+    converter.notifyZoomChanged();
+
+    // image pixels == flake pixels
+
+    QRectF viewportRect = converter.imageToViewport(testRect);
+    QRectF widgetRect = converter.viewportToWidget(viewportRect);
+
+    QCOMPARE(widgetRect, QRectF(300,0,200,200));
+    QCOMPARE(viewportRect, QRectF(0,0,200,200));
+
+    QRectF roundTrip = converter.viewportToWidget(widgetRect);
+    QCOMPARE(roundTrip, viewportRect);
+}
+
+void KisCoordinatesConverterTest::testMirroringCanvasBiggerThanImage()
+{
+    KisImageSP image;
+    KoZoomHandler *zoomHandler;
+    initImage(&image, &zoomHandler);
+
+    KisCoordinatesConverter converter(zoomHandler);
+
+    QSize widgetSize(2000,2000);
+    QSize flakeSize(1000,1000);
+    QRectF testRect(300, 100, 200, 200);
+
+    converter.setImage(image);
+    converter.setDocumentOrigin(QPoint(50,50));
+    converter.setDocumentOffset(QPoint(0,0));
+    converter.setCanvasWidgetSize(widgetSize);
+
+    QTransform postprocessingTransform;
+    postprocessingTransform.scale(-1,1);
+    converter.setPostprocessingTransform(postprocessingTransform);
+
+    QTransform imageToWidget;
+    QTransform documentToWidget;
+    QTransform flakeToWidget;
+    QTransform viewportToWidget;
+
+    zoomHandler->setZoom(1.);
+    converter.notifyZoomChanged();
+
+    // image pixels == flake pixels
+
+    QRectF viewportRect = converter.imageToViewport(testRect);
+    QRectF widgetRect = converter.viewportToWidget(viewportRect);
+
+    QCOMPARE(widgetRect, QRectF(550,150,200,200));
+    QCOMPARE(viewportRect, QRectF(300,100,200,200));
+}
+
+
+QTEST_KDEMAIN(KisCoordinatesConverterTest, GUI)
+#include "kis_coordinates_converter_test.moc"
+
Index: krita/ui/tests/kis_image_view_converter_test.cpp
===================================================================
--- krita/ui/tests/kis_image_view_converter_test.cpp	(revision 1163293)
+++ krita/ui/tests/kis_image_view_converter_test.cpp	(working copy)
@@ -34,7 +34,7 @@
 void KisImageViewConverterTest::testDocumentToView()
 {
     const KoColorSpace * colorSpace = KoColorSpaceRegistry::instance()->rgb8();
-    KisImageWSP image = new KisImage(0, 512, 512, colorSpace, "test");
+    KisImageSP image = new KisImage(0, 512, 512, colorSpace, "test");
     KisImageViewConverter viewConverter(image);
 
     image->setResolution(1.38888888, 1.38888888);
@@ -64,7 +64,7 @@
 void KisImageViewConverterTest::testViewToDocument()
 {
     const KoColorSpace * colorSpace = KoColorSpaceRegistry::instance()->rgb8();
-    KisImageWSP image = new KisImage(0, 512, 512, colorSpace, "test");
+    KisImageSP image = new KisImage(0, 512, 512, colorSpace, "test");
     KisImageViewConverter viewConverter(image);
 
     image->setResolution(1.38888888, 1.38888888);
@@ -94,7 +94,7 @@
 void KisImageViewConverterTest::testZoom()
 {
     const KoColorSpace * colorSpace = KoColorSpaceRegistry::instance()->rgb8();
-    KisImageWSP image = new KisImage(0, 512, 512, colorSpace, "test");
+    KisImageSP image = new KisImage(0, 512, 512, colorSpace, "test");
     KisImageViewConverter viewConverter(image);
 
     image->setResolution(1.38888888, 5.38888888);
